package net.laparola.core;

import java.io.*;
import java.text.Collator;
import java.util.*;

//TODO beta 3
//parole ricercate non sottolineate bene se titolo dentro il versetto (1Cor 12:31)
//Ricerca in brano
//collegamenti cliccabili nei riferimenti (<a href="1Cor 13">1Cor 13</a> oppure <a href="Matteo 5,1-7,28">Discorso della montagna</a>)
//scaricare da Internet; vedi http://www.devdaily.com/java/jwarehouse/apps-for-android/CLiCkin2DaBeaT/src/com/google/clickin2dabeat/Unzipper.java.shtml
// biblioteca: cancella, sposta da/a SD, aggiorna, aggiungi, info
//guida (per Linux usa http://emilian-bold.blogspot.com/2006/08/netbeans-platform-branding-help-with.html)
//info output come unicode? lista parole nella giusta codepage?
//controlla Sal 24 in CEI (due titoli)
// impostazioni

//TODO altro
// preferiti/segnalibri, condividi
// commentari, dizionari, libri
// testi greci, ebraici
// testo scorrevole

//#NB
import org.openide.util.lookup.ServiceProvider;

//#NB
@ServiceProvider(service = TestiAPI.class)
public class Testi extends Object implements Closeable, TestiAPI {
//#eclipse
//public class Testi extends Object implements Closeable {
	private Map<String, Testo> listaVersioni = null;
	private FormatoTesto formato;

	FormatoTesto getFormato() {
		return formato;
		// set { formato = value; }
	}

	// public static final String LIBRI_NOMI_INGLESE =
	// "|Genesis|Exodus|Leviticus|Numbers|Deuteronomy|Joshua|Judges|Ruth|1Samuel|2Samuel|1Kings|2Kings|1Chronicles|2Chronicles|Ezra|Nehemiah|Tobit|Judith|Esther|1Maccabees|2Maccabees|Job|Psalms|Proverbs|Ecclesiastes|Song of Songs|Wisdom|Sirach|Isaiah|Jeremiah|Lamentations|Baruch|Ezekiel|Daniel|Hosea|Joel|Amos|Obadiah|Jonah|Micah|Nahum|Habakkuk|Zephaniah|Haggai|Zechariah|Malachi|Matthew|Mark|Luke|John|Acts|Romans|1Corinthians|2Corinthians|Galatians|Ephesians|Philippians|Colossians|1Thessalonians|2Thessalonians|1Timothy|2Timothy|Titus|Philemon|Hebrews|James|1Peter|2Peter|1John|2John|3John|Jude|Revelation";
	public static final String LIBRI_NOMI_ITALIANO = "|Genesi|Esodo|Levitico|Numeri|Deuteronomio|Giosuè|Giudici|Rut|1Samuele|2Samuele|1Re|2Re|1Cronache|2Cronache|Esdra|Neemia|Tobia|Giuditta|Ester|1Maccabei|2Maccabei|Giobbe|Salmi|Proverbi|Ecclesiaste|Cantico|Sapienza|Siracide|Isaia|Geremia|Lamentazioni|Baruc|Ezechiele|Daniele|Osea|Gioele|Amos|Abdia|Giona|Michea|Naum|Abacuc|Sofonia|Aggeo|Zaccaria|Malachia|Matteo|Marco|Luca|Giovanni|Atti|Romani|1Corinzi|2Corinzi|Galati|Efesini|Filippesi|Colossesi|1Tessalonicesi|2Tessalonicesi|1Timoteo|2Timoteo|Tito|Filemone|Ebrei|Giacomo|1Pietro|2Pietro|1Giovanni|2Giovanni|3Giovanni|Giuda|Apocalisse";
	// private static final String LIBRI_ABBREVIAZIONI_USATE_ENGLISH =
	// "|Gen|Ex|Le|Nu|De|Josh|Judg|Ru|1Sam|2Sam|1K|2K|1Chr|2Chr|Ezra|Ne|Tob|Judi|Est|1M|2M|Job|Ps|Prov|Ec|SS|Wis|Sir|Is|Jer|Lam|Bar|Ezek|Dan|Hos|Joel|Am|Ob|Jon|Mi|Na|Hab|Zep|Hag|Zec|Mal|Mat|Mar|Lu|John|Ac|Ro|1Co|2Co|Ga|Eph|Phili|Col|1Th|2Th|1Ti|2Ti|Tit|Phile|Heb|Jam|1P|2P|1J|2J|3J|Jude|Rev";
	private static final String LIBRI_ABBREVIAZIONI_USATE_ITALIANO = "|Gen|Eso|Le|Nu|De|Gios|Giudic|Ru|1Sam|2Sam|1Re|2Re|1Cr|2Cr|Esd|Ne|Tob|Giudit|Est|1Macc|2Macc|Giob|Sal|Prov|Ec|CC|Sap|Sir|Is|Ger|Lam|Bar|Ez|Da|Os|Gioe|Am|Abd|Gion|Mi|Na|Abac|So|Ag|Zac|Mal|Mt|Mc|Lc|Gv|At|Rm|1Cor|2Cor|Gal|Ef|Fili|Col|1Ts|2Ts|1Tm|2Tm|Tt|Fm|Eb|Giac|1P|2P|1G|2G|3G|Giuda|Ap";
	// private static final String LibriAbbreviazioniRiconosciuteInglese =
	// "|gen,gn|ex|le,lv|nm,nu|de,dt|jos,js|judg,jg|rt,ru|1 s,1s,isam|2 s,2s,iis|1 k,1k,ik|2 k,2k,iik|1 ch,1ch,ich|2 ch,2ch,iich|ezr|ne|tb,to|jdt,jt,judi|est,et|1 m,1m,im|2 m,2m,iim|jb,job|ps|pr,pv|ec|so,ss|w|si|is|je,jr|la|b|ez|da,dn|ho|jl,joe|am|o|jon|mi|na|hab|zep|hag|zec|mal,ml|mat,mt|mar,mk,mr|lk,lu|jn,joh|ac|rm,ro|1 co,1co,ico|2 co,2co,iico|ga|ep|phi,php,pl|cl,co|1 th,1th,1ts,ith|2 th,2th,2ts,iith|1 ti,1ti,1tm,iti|2 ti,2ti,2tm,iiti|ti,tt|phile,phlm,phm,pm|he|jam,jas,jm|1 p,1p,ip|2 p,2p,iip|1 j,1j,ij|2 j,2j,iij|3 j,3j,iiij|jd,jude|re";
	private static final String LIBRI_ABBREVIAZIONI_RICONOSCIUTE_ITALIANO = "|ge,gn|eo,es|le,lv|nm,nu|de,dt|gios,gs|gdc,giudic|rt,ru|1 s,1s,isam|2 s,2s,iis|1 r,1r,ir|2 r,2r,iir|1 cr,1cr,icr|2 cr,2cr,iicr|ed,esd|ne|tb,to|giudit|est,et|1 m,1m,im|2 m,2m,iim|gb,giob|sal,sl|pr,pv|ec,q|ca,cc,ct|sap|si|is|ger,gr|la|b|ez|da,dn|o|gioe,gl|am|abd,ad|gion|mi|na|aba,ac,h|so|ag|z|mal,ml|mat,mt|mar,mc,mr|lc,lu|giov,gv|at|rm,ro|1 co,1co,ico|2 co,2co,iico|ga|ef|fili,fl|cl,co|1 te,1te,1ts,ite|2 te,2te,2ts,iite|1 ti,1ti,1tm,iti|2 ti,2ti,2tm,iiti|ti,tt|file,fm|eb|gc,gia,gm|1 p,1p,ip|2 p,2p,iip|1 g,1g,ig|2 g,2g,iig|3 g,3g,iiig|gd,giuda|ap";
	static final String[] PAROLE_ITALIANE_CON_APOSTROFE = { "be", "co", "com", "da", "di", "die", "dov", "e", "fa", "fe", "mo", "pe", "po", "quant", "que", "rifa", "sta", "va" };
	static final String[] PAROLE_INGLESI_SENZA_APOSTROFE = { "amiss", "apostates", "commandments", "fillets", "holiness", "intercessions", "means", "prayer-fillets", "prayers",
			"prays", "righteous", "terms", "us", "was", "yes" };
	String[] libriNomi;
	String[] libriAbbreviazioniUsate;
	private LibriAbbreviazioniRiconosciuteHash libriAbbreviazioniRiconosciute;

	public enum TestoTipi {
		None, Bibbia, Commentario, Dizionario, Libro
	};

	public enum TestoVisualizzato {
		Versetti, Paragrafi, Nessuno
	};

	public enum RiferimentoTipo {
		DuePunti, Virgola, Citazione
	};

	public enum RiferimentoFormato {
		Intero, Abbreviazione, Nessuno, NessunoLibro, AbbreviazioneRiconosciuta
	};

	public enum RiferimentoPosto {

		PrimaStessaRiga, PrimaRigaDiversa, Dopo
	};

	public class RiferimentoDiverso {
		public int libroStandard;
		public int capitoloStandard;
		public int versettoStandard;
		public int libroVersione;
		public int capitoloVersione;
		public int versettoVersione;
	}

	public Collator confrontoParole;

	public Testi() {
		listaVersioni = new HashMap<String, Testo>();
		libriNomi = LIBRI_NOMI_ITALIANO.split("\\|");
		libriAbbreviazioniUsate = LIBRI_ABBREVIAZIONI_USATE_ITALIANO.split("\\|");
		libriAbbreviazioniRiconosciute = new LibriAbbreviazioniRiconosciuteHash();
		String[] abbreviazioniItaliane = LIBRI_ABBREVIAZIONI_RICONOSCIUTE_ITALIANO.split("\\|");
		String[] abbreviazioni;
		for (int i = 1; i <= 73; ++i) {
			abbreviazioni = abbreviazioniItaliane[i].split(",");
			for (int j = 0; j < abbreviazioni.length; ++j) {
				libriAbbreviazioniRiconosciute.put(abbreviazioni[j], i);
			}
		}

		formato = new FormatoTesto();

		confrontoParole = Collator.getInstance(Locale.ITALY);
		confrontoParole.setStrength(Collator.SECONDARY);
	}

	// #NB
	 @Override
	public void aggiungiTestiDaDirectory(String directory) {
		File dir = new File(directory);

		FilenameFilter filter = new FilenameFilter() {

			// #NB
			 @Override
			public boolean accept(File dir, String name) {
				return name.endsWith(".lpj");
			}
		};
		String[] children = dir.list(filter);
		if (children == null) // "dir" non era una directory valida
		{
			children = new String[0];
		}

		if (!directory.equals("")) {
			directory += File.separator;
		}
		for (int i = 0; i < children.length; i++) {
			try {
				Testo t = new Testo(this, directory + children[i]);
				listaVersioni.put(children[i].substring(0, children[i].length() - 4), t);
			} catch (FileNonValidoException e) {
				// il file non è aggiunto se non poteva essere aperto
			}
		}
	}

	// public void aggiungiTestoDaInputStream (FileInputStream is, String nome) throws FileNonValidoException {
	// Testo t = new Testo(is);
	// listaVersioni.put(nome, t);
	// }

	// #NB
	 @Override
	public void close() {
		Iterator<Testo> it = listaVersioni.values().iterator();
		while (it.hasNext()) {
			it.next().chiudi();
		}
	}

	// #NB
	 @Override
	public String[] nomiVersioni() {
		String[] nomi = new String[listaVersioni.size()];

		Iterator<String> it = listaVersioni.keySet().iterator();
		int i = 0;
		while (it.hasNext()) {
			nomi[i] = it.next();
			i += 1;
		}
		Arrays.sort(nomi);
		return nomi;
	}

	public String getLibroAbbreviazioneUsata(int numeroLibro) {
		return ((numeroLibro >= 1 && numeroLibro <= 73) ? libriAbbreviazioniUsate[numeroLibro] : "");
	}

	public void setLibroAbbreviazioneUsata(int numeroLibro, String nome) {
		if (numeroLibro >= 1 && numeroLibro <= 73) {
			libriAbbreviazioniUsate[numeroLibro] = nome;
		}
	}

	LibriAbbreviazioniRiconosciuteHash getLibriAbbreviazioniRiconosciute() {
		return libriAbbreviazioniRiconosciute;
	}

	// La radice di una certa parola in un testo.
	public String radiceDiParola(String parola, String nomeVersione) {
		if (nomeVersione == null)
			return parola;
		else {
			return getTesto(nomeVersione).radiceDiParola(parola);
		}
	}

	// #NB
	 @Override
	public CharSequence getBrano(String riferimento, String nomeVersione) {
		return getBrano(convertiRiferimento(riferimento), nomeVersione);
	}

	public CharSequence getBrano(Riferimento riferimento, String nomeVersione) {
		return getTesto(nomeVersione).getBrano(riferimento, new Riferimento());
	}

	public Testo getTesto(String nomeVersione) {
		return listaVersioni.get(nomeVersione);
	}

	public Riferimento ricerca(String espressione, String riferimentoDaRicercare, String nomeVersione) throws RicercaEspressioneVuotaException, RicercaErroreSintassiException,
			RicercaParentesiException, RicercaParentesiQuadrateException {
		return ricerca(espressione, convertiRiferimento(riferimentoDaRicercare), nomeVersione);
	}

	public Riferimento ricerca(String espressione, Riferimento riferimentoDaRicercare, String nomeVersione) throws RicercaEspressioneVuotaException,
			RicercaErroreSintassiException, RicercaParentesiException, RicercaParentesiQuadrateException {
		espressione = ControllaEspressioneDaRicercare(espressione, nomeVersione);
		Riferimento versettiTrovati = TrovaOccorrenzeEspressione(espressione, riferimentoDaRicercare, false, 0, nomeVersione);
		versettiTrovati = unisciVociRipetute(versettiTrovati);
		return versettiTrovati;
	}

	private String ControllaEspressioneDaRicercare(String espressioneDaControllare, String nomeVersione) throws RicercaEspressioneVuotaException, RicercaErroreSintassiException,
			RicercaParentesiException, RicercaParentesiQuadrateException {
		StringBuilder espressione = new StringBuilder(espressioneDaControllare.trim().toLowerCase().replace(' ', ' ').replace('^', '~').replace('!', '|'));
		// il primo spazio è il carattere hexA0 (spazio unificatore), il secondo hex20 (spazio normale)
		if (espressione.length()==0)
			throw new RicercaEspressioneVuotaException();
		int nParentesiSinistra = 0, nParentesiDestra = 0, nParentesiQuadrateSinistra = 0;
		int erroreSintassi = -1;
		boolean erroreParentesi = false, erroreParentesiQuadrate = false;
		char a, b, c;

		if (Arrays.asList(getTesto(nomeVersione).getInfo().getLingua().toLowerCase().split("\\|")).indexOf("it") >= 0) {
			int p = 0;
			while (espressione.indexOf("'", p + 1) > -1) {
				p = espressione.indexOf("'", p + 1);
				if (p < espressione.length() - 1 && (funzioni.isLettera(espressione.charAt(p + 1)) || espressione.charAt(p + 1) == '*' || espressione.charAt(p + 1) == '?'))
					espressione = espressione.insert(p + 1, " ");
			}
		}

		char prossimaParentesiQuadrate = '[';
		while (espressione.indexOf("\"") >= 0) {
			espressione.insert(espressione.indexOf("\""), prossimaParentesiQuadrate);
			prossimaParentesiQuadrate = (prossimaParentesiQuadrate == '[' ? ']' : '[');
		}

		for (int i = 0; i < espressione.length() - 1; ++i) {
			c = espressione.charAt(i);
			if (c == ' ' && i > 1) {
				a = espressione.charAt(i - 1);
				b = espressione.charAt(i + 1);
				if ((a < 'a' && a != '\'' && a != '-' && a != ']' && a != ')' && !(funzioni.isLettera(a) || a == '*' || a == '?')) || a == '~' || a == '|' || a == ':' || a == '<'
						|| a == '>' || (b < 'a' && b != '\'' && b != '-' && b != '(' && b != '[' && !(funzioni.isLettera(b) || b == '*' || b == '?')) || b == '~' || b == '|'
						|| b == ':' || b == '<' || a == '>') {
					espressione = espressione.deleteCharAt(i);
					--i;
				}
			}
		}

		for (int i = 0; i < espressione.length(); ++i) {
			c = espressione.charAt(i);
			if (i == 0) {
				if (c == '(')
					++nParentesiSinistra;
				else if (c == '[')
					++nParentesiQuadrateSinistra;
				else if (c == '<') {
					int nuovoI = espressione.indexOf(">", i);
					if (nuovoI > i)
						i = nuovoI;
					else
						erroreSintassi = i;
				} else if (!(funzioni.isLettera(c) || c == '\'' || c == '/' || c == '\\' || c == '*' || c == '?'))
					erroreSintassi = i;
			} else {
				a = espressione.charAt(i - 1);
				if (c == ' ') {
					espressione = espressione.deleteCharAt(i);
					espressione = espressione.insert(i, "0");
				} else if (c == '-' || c == '\'') {
					if (!(funzioni.isLettera(a) || a == '*' || a == '?'))
						erroreSintassi = i;
				} else if (c == '/' || c == '\\') {
					if (a == '/' || a == '\\' || a == '<')
						erroreSintassi = i;
					else {
						if (a != '|' && a != ':' && a != '~' && (!Character.isDigit(a)) && a != '(' && a != '[') {
							espressione = espressione.insert(i, "0");
							++i;
						}
					}
				} else if (c == '(') {
					++nParentesiSinistra;
					if (nParentesiQuadrateSinistra > 0 && nParentesiSinistra > 1)
						erroreParentesiQuadrate = true;
					if (a == '/' || a == '\\' || a == ':' || a == '<')
						erroreSintassi = i;
					else {
						if (a != '|' && a != '~' && a != '[' && (!Character.isDigit(a))) {
							espressione = espressione.insert(i, "0");
							++i;
						}
					}
				} else if (c == ')') {
					++nParentesiDestra;
					if (nParentesiDestra > nParentesiSinistra)
						erroreParentesi = true;
					if ((a >= '/' && a <= ':') || a == '|' || a == '~' || a == '\\' || a == '<')
						erroreSintassi = i;
				} else if (c == '[') {
					++nParentesiQuadrateSinistra;
					if (nParentesiQuadrateSinistra > 1)
						erroreParentesiQuadrate = true;
					if (a == '/' || a == '\\' || a == ':' || a == '<')
						erroreSintassi = i;
					else {
						if (a != '|' && a != '~' && (!Character.isDigit(a))) {
							espressione = espressione.insert(i, "0");
							++i;
						}
					}
				} else if (c == ']') {
					nParentesiQuadrateSinistra--;
					if (nParentesiQuadrateSinistra < 0)
						erroreParentesiQuadrate = true;
					if (nParentesiDestra - nParentesiSinistra < 0)
						erroreParentesi = true;
					if (Character.isDigit(a) || a == '/' || a == ':' || a == '|' || a == '~' || a == '\\' || a == '<')
						erroreSintassi = i;
				} else if (c == '|' || Character.isDigit(c)) {
					if (a != ')' && a != ']' && a != '<' && a != '>' && !(funzioni.isLettera(a) || a == '*' || a == '?'))
						erroreSintassi = i;
					if (nParentesiQuadrateSinistra == 1 && c == '|') {
						b = 'a';
						int j;
						for (j = i + 1; b != ']' && (!Character.isDigit(b)) && b != ':' && j < espressione.length(); ++j)
							b = espressione.charAt(j);
						espressione = espressione.insert(j - 1, ")");
						b = 'a';
						for (j = i - 1; b != '[' && (!Character.isDigit(b)) && b != ':' && j >= 0; --j)
							b = espressione.charAt(j);
						espressione = espressione.insert(j + 2, "(");
						++i;
						++nParentesiSinistra;
					}
				} else if (c == ':') {
					if ((a != ')' && a != '>' && !(funzioni.isLettera(a) || a == '*' || a == '?')) || nParentesiQuadrateSinistra == 0)
						erroreSintassi = i;
				} else if (c == '~') {
					if (a == '<' || a == '(' || a == '[' || a == ':' || a == '/' || a == '|' || a == '~' || a == '\\'
							|| (nParentesiQuadrateSinistra == 1 && nParentesiSinistra > 0))
						erroreSintassi = i;
					else {
						if (a == ')' || a > ']' || funzioni.isLettera(a) || a == '*' || a == '?') {
							espressione = espressione.insert(i, "0");
							++i;
						}
					}
					if (nParentesiQuadrateSinistra == 1
							&& (funzioni.isLettera(espressione.charAt(i + 1)) || espressione.charAt(i + 1) == '*' || espressione.charAt(i + 1) == '?'
									|| espressione.charAt(i + 1) == '/' || espressione.charAt(i + 1) == '\\')) {
						espressione = espressione.insert(i + 1, "(");
						int j;
						b = 'a';
						for (j = i + 2; b != ']' && (!Character.isDigit(b)) && b != ':' && j < espressione.length(); ++j)
							b = espressione.charAt(j);
						espressione = espressione.insert(j, ")");
					}
				} else if (c == '>') {
				} else if (c == '<') {
					if (a == ')' || a == ']' || a == '>' || funzioni.isLettera(a) || a == '*' || a == '?') {
						espressione = espressione.insert(i, "0");
						++i;
					}
					int nuovoI = espressione.indexOf(">", i);
					if (nuovoI > i)
						i = nuovoI;
					else
						erroreSintassi = i;
				} else if (funzioni.isLettera(c) || c == '*' || c == '?' || c == '<') { // lettera (senza o con accento)
					if (a == ')' || a == ']' || a == '>') {
						espressione = espressione.insert(i, "0");
						++i;
					}
				} else
					// carattere non riconosciuto
					erroreSintassi = i;
			} // if (i == 0) - else
		} // for (int i = 0; i < espressione.Length; ++i)

		a = espressione.charAt(espressione.length() - 1);
		if (!(a == ')' || a == ']' || a == '-' || a == '\'' || funzioni.isLettera(a) || a == '*' || a == '?' || a == '>'))
			erroreSintassi = espressione.length() - 1;

		if (nParentesiSinistra != nParentesiDestra)
			erroreParentesi = true;
		if (nParentesiQuadrateSinistra == 1)
			erroreParentesiQuadrate = true;
		if (erroreParentesiQuadrate)
			erroreParentesi = false; // indicare solo uno degli errori
		if (erroreSintassi >= 0)
			throw new RicercaErroreSintassiException(Integer.toString(erroreSintassi));
		if (erroreParentesi)
			throw new RicercaParentesiException();
		if (erroreParentesiQuadrate)
			throw new RicercaParentesiQuadrateException();
		return espressione.toString();
	}

	private static Riferimento unisciVociRipetute(Riferimento riferimento) {
		if (riferimento.getVersetti()) {
			int nVersetti = riferimento.getBrani().size();
			for (int i = nVersetti - 1; i > 0; --i) {
				if (riferimento.primoVersettoUguale(i - 1, i)) {
					riferimento.aggiungiNumeroParola(i - 1, riferimento.getNumeroParola(i));
					riferimento.rimuoviBrano(i);
				} else
					riferimento.ordinaParole(i);
			}
			if (nVersetti > 0)
				riferimento.ordinaParole(0);
		} else {
			int nNote = riferimento.getNote().size();
			for (int i = nNote - 1; i > 0; --i) {
				if (riferimento.getNote().get(i - 1).equals(riferimento.getNote().get(i))) {
					riferimento.aggiungiNumeroParola(i - 1, riferimento.getNumeroParola(i));
					riferimento.rimuoviNota(i);
				} else
					riferimento.ordinaParole(i);
			}
			if (nNote > 0)
				riferimento.ordinaParole(0);
		}
		return riferimento;
	}

	private Riferimento TrovaOccorrenzeEspressione(String espressione, Riferimento branoDaRicercare, boolean inFrase, int nParoleInFrase, String nomeVersione) {
		// se branoDaRicerca non contiene brani, tutta la Bibbia (oppure tutta la collezione di note) è ricercata
		String espressioneDaTrovare = espressione;
		espressioneDaTrovare += (char) 0;
		Riferimento riferimenti = new Riferimento();
		String tipoOperazione;
		while (espressioneDaTrovare.length() > 1) { // altrimenti rimane solo char(0)
			char primoCarattere = espressioneDaTrovare.charAt(0);
			if (primoCarattere == '~') {
				primoCarattere = '0';
				espressioneDaTrovare = "0" + espressioneDaTrovare;
			}
			if (Character.isDigit(primoCarattere) || primoCarattere == ':') {
				if (Character.isDigit(espressioneDaTrovare.charAt(1)))
					tipoOperazione = "prima";
				else {
					tipoOperazione = espressioneDaTrovare.substring(0, 1);
					espressioneDaTrovare = espressioneDaTrovare.substring(1);
					if (espressioneDaTrovare.charAt(0) == '~') {
						tipoOperazione += "n";
						espressioneDaTrovare = espressioneDaTrovare.substring(1);
					}
				}
			} else {
				if (primoCarattere == '|') {
					tipoOperazione = "oppure";
					espressioneDaTrovare = espressioneDaTrovare.substring(1);
				} else
					tipoOperazione = "prima";
			} // if ((IsNumero(cPrimoCarattere)) || cPrimoCarattere==':') else

			int i;
			Riferimento occorrenzeProssimaParola = new Riferimento();
			primoCarattere = espressioneDaTrovare.charAt(0);
			if (primoCarattere == '(') {
				i = 0;
				int nParentesi = 1;
				do {
					++i;
					if (espressioneDaTrovare.charAt(i) == ')')
						--nParentesi;
					if (espressioneDaTrovare.charAt(i) == '(')
						++nParentesi;
				} while (nParentesi != 0);
				occorrenzeProssimaParola = TrovaOccorrenzeEspressione(espressioneDaTrovare.substring(1, i ), branoDaRicercare, false, nParoleInFrase, nomeVersione);
				espressioneDaTrovare = espressioneDaTrovare.substring(i + 1);
			} else if (primoCarattere == '[') {
				i = espressioneDaTrovare.indexOf("]");
				nParoleInFrase = 0;
				occorrenzeProssimaParola = TrovaOccorrenzeEspressione(espressioneDaTrovare.substring(1, i ), branoDaRicercare, true, nParoleInFrase, nomeVersione);
				espressioneDaTrovare = espressioneDaTrovare.substring(i + 1);
			} else {
				String parola = ProssimaParola(espressioneDaTrovare, 0);
				occorrenzeProssimaParola = getTesto(nomeVersione).ricercaParolaInBrano(parola, branoDaRicercare);
				int lunghezzaExtra = (espressioneDaTrovare.charAt(0) == '<' ? 1 : 0);
				if (lunghezzaExtra == 1 && espressioneDaTrovare.indexOf(">") >= 0)
					++lunghezzaExtra;
				espressioneDaTrovare = espressioneDaTrovare.substring(parola.length() + lunghezzaExtra);
				++nParoleInFrase;
			} // if (cPrimoCarattere=='(') else

			Riferimento occorrenzeInBrano = new Riferimento();
			if (tipoOperazione.equals("prima"))
				riferimenti = occorrenzeProssimaParola;
			else {
				primoCarattere = tipoOperazione.charAt(0);
				if (Character.isDigit(primoCarattere) || primoCarattere == ':') {
					int primoCarattereComeNumero;
					if (primoCarattere == ':')
						primoCarattereComeNumero = Integer.MAX_VALUE / 2;
					else
						primoCarattereComeNumero = Character.getNumericValue(primoCarattere);
					if (!inFrase || tipoOperazione.length() == 1) {
						if (riferimenti.getVersetti()) {
							int j = i = 1;
							int nI = riferimenti.count();
							int nJ = occorrenzeProssimaParola.count();
							int nVersettoRiferimenti = (nI > 0 ? (versettiFinoACapitolo(riferimenti.getBrani().get(i - 1)[0], riferimenti.getBrani().get(i - 1)[1] - 1,
									nomeVersione) + riferimenti.getBrani().get(i - 1)[2]) : 0);
							int nVersettoOccorrenze = (nJ > 0 ? (versettiFinoACapitolo(occorrenzeProssimaParola.getBrani().get(j - 1)[0],
									occorrenzeProssimaParola.getBrani().get(j - 1)[1] - 1, nomeVersione) + occorrenzeProssimaParola.getBrani().get(j - 1)[2]) : 0);
							while (i <= nI && j <= nJ) {
								if (inFrase) {
									if (nVersettoOccorrenze < nVersettoRiferimenti
											|| (nVersettoOccorrenze == nVersettoRiferimenti && occorrenzeProssimaParola.getNumeroParola(j - 1).get(0) < riferimenti
													.getNumeroParola(i - 1).get(0))) {
										++j;
										if (j <= nJ)
											nVersettoOccorrenze = versettiFinoACapitolo(occorrenzeProssimaParola.getBrani().get(j - 1)[0],
													occorrenzeProssimaParola.getBrani().get(j - 1)[1] - 1, nomeVersione)
													+ occorrenzeProssimaParola.getBrani().get(j - 1)[2];
									} else {
										if (nVersettoOccorrenze > nVersettoRiferimenti
												|| (nVersettoOccorrenze == nVersettoRiferimenti && occorrenzeProssimaParola.getNumeroParola(j - 1).get(0) > riferimenti
														.getNumeroParola(i - 1).get(0) + primoCarattereComeNumero + 1)) {
											if (tipoOperazione.length() > 1) {
												occorrenzeInBrano.aggiungiBranoNumeroParola(riferimenti.getBrani().get(i - 1), riferimenti.getNumeroParola(i - 1));
											}
										} else {
											if (tipoOperazione.length() == 1) {
												occorrenzeInBrano.aggiungiBranoNumeroParola(riferimenti.getBrani().get(i - 1), riferimenti.getNumeroParola(i - 1));
												occorrenzeInBrano.inserisciNumeroParola(occorrenzeInBrano.countNumeroParola() - 1, 0,
														occorrenzeProssimaParola.getNumeroParola(j - 1).get(0));
											}
										}
										++i;
										if (i <= nI)
											nVersettoRiferimenti = versettiFinoACapitolo(riferimenti.getBrani().get(i - 1)[0], riferimenti.getBrani().get(i - 1)[1] - 1,
													nomeVersione) + riferimenti.getBrani().get(i - 1)[2];
									}
								} else {
									if (nVersettoOccorrenze < nVersettoRiferimenti - primoCarattereComeNumero) {
										++j;
										if (j <= nJ)
											nVersettoOccorrenze = versettiFinoACapitolo(occorrenzeProssimaParola.getBrani().get(j - 1)[0],
													occorrenzeProssimaParola.getBrani().get(j - 1)[1] - 1, nomeVersione)
													+ occorrenzeProssimaParola.getBrani().get(j - 1)[2];
									} else {
										if (nVersettoOccorrenze > nVersettoRiferimenti + primoCarattereComeNumero) {
											if (tipoOperazione.length() > 1) {
												occorrenzeInBrano.aggiungiBranoNumeroParola(riferimenti.getBrani().get(i - 1), riferimenti.getNumeroParola(i - 1));
											}
										} else {
											if (tipoOperazione.length() == 1) {
												occorrenzeInBrano.aggiungiBranoNumeroParola(riferimenti.getBrani().get(i - 1), riferimenti.getNumeroParola(i - 1));
												if (primoCarattereComeNumero == 0) { // seconda parola nel versetto anche, quindi va sottolineata
													occorrenzeInBrano.inserisciNumeroParola(occorrenzeInBrano.countNumeroParola() - 1, 0,
															occorrenzeProssimaParola.getNumeroParola(j - 1).get(0));
													while (j < nJ && occorrenzeProssimaParola.primoVersettoUguale(j - 1, j)) {
														occorrenzeInBrano.aggiungiNumeroParola(occorrenzeInBrano.countNumeroParola() - 1,
																occorrenzeProssimaParola.getNumeroParola(j).get(0));
														++j;
													}
												}
											}
										}
										++i;
										if (i <= nI)
											nVersettoRiferimenti = versettiFinoACapitolo(riferimenti.getBrani().get(i - 1)[0], riferimenti.getBrani().get(i - 1)[1] - 1,
													nomeVersione) + riferimenti.getBrani().get(i - 1)[2];
									}
								}
							} // while (i <= riferimenti.Count && j <= occorrenzeProssimaParola.Count)
							if (tipoOperazione.length() > 1) {
								while (i <= riferimenti.count()) {
									occorrenzeInBrano.aggiungiBranoNumeroParola(riferimenti.getBrani().get(i - 1), riferimenti.getNumeroParola(i - 1));
									++i;
								}
							}
							riferimenti = occorrenzeInBrano;
						} else // if (riferimenti.Versetti)
						{
							occorrenzeInBrano.setVersetti(false);
							int j = i = 1;
							int nI = riferimenti.count();
							int nJ = occorrenzeProssimaParola.count();
							String notaRiferimenti = (nI > 0 ? riferimenti.getNote().get(i - 1) : "");
							String notaOccorrenze = (nJ > 0 ? occorrenzeProssimaParola.getNote().get(j - 1) : "");
							int[] differenze = { -1, primoCarattereComeNumero }; // [0] = differenzaVersetti, [1] = differenzaRicercata
							// int differenzaVersetti = -1;
							// int differenzaRicercata = primoCarattereComeNumero;
							while (i <= nI && j <= nJ) {
								if (inFrase) {
									if (notaOccorrenze.compareTo(notaRiferimenti) < 0
											|| (notaOccorrenze.equals(notaRiferimenti) && occorrenzeProssimaParola.getNumeroParola(j - 1).get(0) < riferimenti.getNumeroParola(i - 1)
													.get(0))) {
										++j;
										if (j <= nJ)
											notaOccorrenze = occorrenzeProssimaParola.getNote().get(j - 1);
									} else {
										if (notaOccorrenze.compareTo(notaRiferimenti) > 0
												|| (notaOccorrenze.equals(notaRiferimenti) && occorrenzeProssimaParola.getNumeroParola(j - 1).get(0) > riferimenti
														.getNumeroParola(i - 1).get(0) + primoCarattereComeNumero + 1)) {
											if (tipoOperazione.length() > 1) {
												occorrenzeInBrano.aggiungiNotaNumeroParola(riferimenti.getNote().get(i - 1), riferimenti.getNumeroParola(i - 1));
											}
										} else {
											if (tipoOperazione.length() == 1) {
												occorrenzeInBrano.aggiungiNotaNumeroParola(riferimenti.getNote().get(i - 1), riferimenti.getNumeroParola(i - 1));
												occorrenzeInBrano.inserisciNumeroParola(occorrenzeInBrano.countNumeroParola() - 1, 0,
														occorrenzeProssimaParola.getNumeroParola(j - 1).get(0));
											}
										}
										++i;
										if (i <= nI)
											notaRiferimenti = riferimenti.getNote().get(i - 1);
									}
								} else {
									differenze = CalcolaDifferenzeDelleNote(primoCarattereComeNumero, notaRiferimenti, notaOccorrenze);
									if (differenze[0] < -differenze[1]) // cioè string.Compare(notaOccorrenze, notaRiferimenti) < 0 per due note quando una non è ad un brano
									{
										++j;
										if (j <= nJ)
											notaOccorrenze = occorrenzeProssimaParola.getNote().get(j - 1);
									} else {
										if (differenze[0] > differenze[1]) // cioè string.Compare(notaOccorrenze, notaRiferimenti) > 0 per due note quando una non è ad un brano
										{
											if (tipoOperazione.length() > 1) {
												occorrenzeInBrano.aggiungiNotaNumeroParola(notaRiferimenti, riferimenti.getNumeroParola(i - 1));
											}
										} else {
											if (tipoOperazione.length() == 1) {
												if (occorrenzeInBrano.getNote().size() > 0
														&& notaRiferimenti.equals(occorrenzeInBrano.getNote().get(occorrenzeInBrano.getNote().size() - 1))) {
													occorrenzeInBrano
															.inserisciNumeroParola(occorrenzeInBrano.countNumeroParola() - 1, 0, riferimenti.getNumeroParola(i - 1).get(0));
												} else {
													occorrenzeInBrano.aggiungiNotaNumeroParola(notaRiferimenti, riferimenti.getNumeroParola(i - 1));
													if (differenze[1] == 0) // seconda parola nel versetto anche, quindi va sottolineata
														occorrenzeInBrano.inserisciNumeroParola(occorrenzeInBrano.countNumeroParola() - 1, 0, occorrenzeProssimaParola
																.getNumeroParola(j - 1).get(0));
												}
												++j;
												if (j <= nJ) {
													notaOccorrenze = occorrenzeProssimaParola.getNote().get(j - 1);
													differenze = CalcolaDifferenzeDelleNote(primoCarattereComeNumero, notaRiferimenti, notaOccorrenze);
												}
												while (Math.abs(differenze[0]) <= differenze[1] && j <= nJ) {
													occorrenzeInBrano.inserisciNumeroParola(occorrenzeInBrano.countNumeroParola() - 1, 0,
															occorrenzeProssimaParola.getNumeroParola(j - 1).get(0));
													++j;
													if (j <= nJ) {
														notaOccorrenze = occorrenzeProssimaParola.getNote().get(j - 1);
														differenze = CalcolaDifferenzeDelleNote(primoCarattereComeNumero, notaRiferimenti, notaOccorrenze);
													}
												}
												while (i < nI && riferimenti.getNote().get(i - 1).equals(riferimenti.getNote().get(i))) {
													++i;
													occorrenzeInBrano
															.inserisciNumeroParola(occorrenzeInBrano.countNumeroParola() - 1, 0, riferimenti.getNumeroParola(i - 1).get(0));
												}
											}
										}
										++i;
										if (i <= nI)
											notaRiferimenti = riferimenti.getNote().get(i - 1);
									}
								}
							} // while (i <= nI && j <= nJ)
							if (tipoOperazione.length() > 1) {
								while (i <= riferimenti.count()) {
									occorrenzeInBrano.aggiungiNotaNumeroParola(riferimenti.getNote().get(i - 1), riferimenti.getNumeroParola(i - 1));
									++i;
								}
							}
							riferimenti = occorrenzeInBrano;
						} // if (riferimenti.Versetti) else
					} // if (!inFrase || tipoOper.Length == 1)
				} // if (Char.IsDigit(primoCarattere)) {
				else {
					if (primoCarattere == 'o') {
						if (riferimenti.getVersetti()) {
							int j = i = 1;
							if (riferimenti.count() > 0 && occorrenzeProssimaParola.count() > 0) {
								int nVersettoRiferimenti = versettiFinoACapitolo(riferimenti.getBrani().get(i - 1)[0], riferimenti.getBrani().get(i - 1)[1] - 1, nomeVersione)
										+ riferimenti.getBrani().get(i - 1)[2];
								int nVersettoOccorrenze = versettiFinoACapitolo(occorrenzeProssimaParola.getBrani().get(j - 1)[0],
										occorrenzeProssimaParola.getBrani().get(j - 1)[1] - 1, nomeVersione) + occorrenzeProssimaParola.getBrani().get(j - 1)[2];
								int nI = riferimenti.count();
								int nJ = occorrenzeProssimaParola.count();
								while (i <= nI && j <= nJ) {
									if (nVersettoOccorrenze < nVersettoRiferimenti
											|| (nVersettoOccorrenze == nVersettoRiferimenti && occorrenzeProssimaParola.getNumeroParola(j - 1).get(0) < riferimenti
													.getNumeroParola(i - 1).get(0))) {
										occorrenzeInBrano
												.aggiungiBranoNumeroParola(occorrenzeProssimaParola.getBrani().get(j - 1), occorrenzeProssimaParola.getNumeroParola(j - 1));
										++j;
										if (j <= nJ)
											nVersettoOccorrenze = versettiFinoACapitolo(occorrenzeProssimaParola.getBrani().get(j - 1)[0], (occorrenzeProssimaParola.getBrani()
													.get(j - 1)[1] - 1), nomeVersione)
													+ occorrenzeProssimaParola.getBrani().get(j - 1)[2];
									} else {
										occorrenzeInBrano.aggiungiBranoNumeroParola(riferimenti.getBrani().get(i - 1), riferimenti.getNumeroParola(i - 1));
										++i;
										if (i <= nI)
											nVersettoRiferimenti = versettiFinoACapitolo(riferimenti.getBrani().get(i - 1)[0], riferimenti.getBrani().get(i - 1)[1] - 1,
													nomeVersione) + riferimenti.getBrani().get(i - 1)[2];
									}
								} // while
							}
							while (j <= occorrenzeProssimaParola.count()) {
								occorrenzeInBrano.aggiungiBranoNumeroParola(occorrenzeProssimaParola.getBrani().get(j - 1), occorrenzeProssimaParola.getNumeroParola(j - 1));
								++j;
							}
							while (i <= riferimenti.count()) {
								occorrenzeInBrano.aggiungiBranoNumeroParola(riferimenti.getBrani().get(i - 1), riferimenti.getNumeroParola(i - 1));
								++i;
							}
							riferimenti = occorrenzeInBrano;
						} else // collezioni di note
						{
							occorrenzeInBrano.setVersetti(false);
							int j = i = 1;
							int nI = riferimenti.count();
							int nJ = occorrenzeProssimaParola.count();
							String notaRiferimenti = (nI > 0 ? riferimenti.getNote().get(i - 1) : "");
							String notaOccorrenze = (nJ > 0 ? occorrenzeProssimaParola.getNote().get(j - 1) : "");
							while (i <= nI && j <= nJ) {
								if (notaOccorrenze.compareTo(notaRiferimenti) < 0
										|| (notaOccorrenze.equals(notaRiferimenti) && occorrenzeProssimaParola.getNumeroParola(j - 1).get(0) < riferimenti.getNumeroParola(i - 1).get(0))) {
									occorrenzeInBrano.aggiungiNotaNumeroParola(occorrenzeProssimaParola.getNote().get(j - 1), occorrenzeProssimaParola.getNumeroParola(j - 1));
									++j;
									if (j < nJ)
										notaOccorrenze = occorrenzeProssimaParola.getNote().get(j - 1);
								} else {
									occorrenzeInBrano.aggiungiNotaNumeroParola(riferimenti.getNote().get(i - 1), riferimenti.getNumeroParola(i - 1));
									++i;
									if (i < nI)
										notaRiferimenti = riferimenti.getNote().get(i - 1);
								}
							} // while
							while (j <= occorrenzeProssimaParola.count()) {
								occorrenzeInBrano.aggiungiNotaNumeroParola(occorrenzeProssimaParola.getNote().get(j - 1), occorrenzeProssimaParola.getNumeroParola(j - 1));
								++j;
							}
							while (i <= riferimenti.count()) {
								occorrenzeInBrano.aggiungiNotaNumeroParola(riferimenti.getNote().get(i - 1), riferimenti.getNumeroParola(i - 1));
								++i;
							}
							riferimenti = occorrenzeInBrano;
						}
					}
				} // if (Char.IsDigit(primoCarattere)) else
			}
		}

		return riferimenti;
	}

	private static String ProssimaParola(String fraseRicercata, int inizio) {
		int j = 0;
		StringBuilder prossimaParola = new StringBuilder("");
		String frase = fraseRicercata.substring(inizio) + " "; // con " ", la riga c = sFraseRicercata[iInizio+j] funziona anche quando passa oltre la fine di sFraseRicercata
		char c = frase.charAt(0);
		if (c == '<') {
			int p = frase.indexOf(">");
			return (p > 0 ? frase.substring(1, p ) : "");
		} else if (Character.isDigit(c)) {
			while (Character.isDigit(c)) {
				prossimaParola.append(c);
				++j;
				c = frase.charAt(j);
			}
		} else {
			while (funzioni.isLettera(c) || c == '-' || c == '\'' || c == '*' || c == '?' || c == '/' || c == '\\') {
				prossimaParola.append(c);
				++j;
				c = frase.charAt(j);
			}
		}

		return prossimaParola.toString();
	}

	private int[] CalcolaDifferenzeDelleNote(int primoCarattereComeNumero, String notaRiferimenti, String notaOccorrenze) {
		int differenzaVersetti = -1;
		int differenzaRicercata = primoCarattereComeNumero;
		if (notaOccorrenze.startsWith("#") && notaRiferimenti.startsWith("#")) {
			differenzaVersetti = VersettiFinoACapitolo(Integer.parseInt(notaOccorrenze.substring(1, 3)), Integer.parseInt(notaOccorrenze.substring(3, 6)))
					+ Integer.parseInt(notaOccorrenze.substring(6, 9))
					- VersettiFinoACapitolo(Integer.parseInt(notaRiferimenti.substring(1, 3)), Integer.parseInt(notaRiferimenti.substring(3, 6)))
					- Integer.parseInt(notaRiferimenti.substring(6, 9));
		} else {
			differenzaVersetti = notaOccorrenze.compareTo(notaRiferimenti);
			differenzaRicercata = 0;
		}
		int[] differenze = { differenzaVersetti, differenzaRicercata };
		return differenze;
	}

	private int VersettiFinoACapitolo(int libro, int capitolo) {
		// TODO invece di Nuova Riveduta dovrebbe essere l'ultima Bibbia completa usata
		return listaVersioni.get("Nuova Riveduta").indiceCapitoli[listaVersioni.get("Nuova Riveduta").indiceLibri[libro - 1] + capitolo];
	}

	public Riferimento convertiRiferimento(String riferimento) {
		Riferimento nuovoRiferimento = new Riferimento();
		riferimento = riferimento.trim().toLowerCase();
		if (riferimento.equals("")) {
			return nuovoRiferimento;
		}

		// cancellare eventuali spazi dopo punteggiatura o un numero (per esempio 2 re)
		for (int i = riferimento.length() - 1; i >= 1; --i) {
			if (riferimento.charAt(i) == ' '
					&& (riferimento.charAt(i - 1) == ':' || riferimento.charAt(i - 1) == ',' || riferimento.charAt(i - 1) == '.' || riferimento.charAt(i - 1) == ';'
							|| riferimento.charAt(i - 1) == '-' || Character.isDigit(riferimento.charAt(i - 1)))) {
				riferimento = funzioni.Rimuovi(riferimento, i, 1);
			}
		}
		// cancellare eventuali punti o virgole dopo il nome di un libro
		// (virgole succede con RIFTIPO_CITAZIONE)
		for (int i = riferimento.length() - 1; i >= 1; --i) {
			if ((riferimento.charAt(i) == '.') && (Character.isLetter(riferimento.charAt(i - 1)))) {
				riferimento = funzioni.Rimuovi(riferimento, i, 1);
			} else {
				if ((riferimento.charAt(i) == ',') && (Character.isLetter(riferimento.charAt(i - 1)))) {
					if (i == riferimento.length() - 1 || (Character.isDigit(riferimento.charAt(i + 1)))
							&& (i == riferimento.length() - 2 || !Character.isLetter(riferimento.charAt(i + 2)))) // non caso di mr,gv o mr,3g ma sì nel caso di mr,3,4
					{
						riferimento = funzioni.Rimuovi(riferimento, i, 1);
					}
				}
			}
		}
		// cancellare eventuali due punti alla fine o prima di punteggiatura (possibile con RIFTIPO_CITAZIONE)
		for (int i = riferimento.length() - 1; i >= 1; --i) {
			if (riferimento.charAt(i) == ':'
					&& (i == riferimento.length() - 1 || (riferimento.charAt(i + 1) == ';' || riferimento.charAt(i + 1) == ',' || riferimento.charAt(i + 1) == '.'))) {
				riferimento = funzioni.Rimuovi(riferimento, i, 1);
			}
		}

		if ((formato.RiferimentoTipo() == RiferimentoTipo.Virgola || formato.RiferimentoTipo() == RiferimentoTipo.Citazione)
				&& (riferimento.indexOf(':') < 0 || riferimento.indexOf(':') >= riferimento.length() - 2)) {
			riferimento = riferimento.replace(',', ':');
			riferimento = riferimento.replace('.', ',');
			while (riferimento.indexOf(';') >= 0) {
				int dopoDivisore = riferimento.indexOf(';') + 1;
				// controlla situazioni come Is 7,1-10;12 che viene tradotto in modo diverso
				while (dopoDivisore <= riferimento.length() - 1 && ((Character.isDigit(riferimento.charAt(dopoDivisore))) || riferimento.charAt(dopoDivisore) == ' ')) {
					++dopoDivisore;
				}
				if (dopoDivisore > riferimento.length() - 1
						|| (riferimento.charAt(dopoDivisore) != ':' && riferimento.charAt(dopoDivisore) != '.' && (!Character.isLetter(riferimento.charAt(dopoDivisore))))) {
					riferimento = riferimento.substring(1, dopoDivisore) + ":1-200" + riferimento.substring(dopoDivisore);
				}
				riferimento = riferimento.replace(';', ',');
			}
		}

		int punteggiature, capitolo = 0;
		boolean trattinoVecchio = true, trattino = false, versettoMancante = false;
		String riferimentoDaAnalizzare, libroNome = "";
		int[] riferimentoBrano = { 0, 0, 0, 0, 0, 0, 0, 0 };
		int[] riferimentoBranoPrecedente = { 0, 0, 0, 0, 0, 0, 0, 0 };
		int[] riferimentoBrano4Byte = { 0, 0, 0, 0, 0, 0, 0, 0 };
		do {
			// troviamo il riferimento del primo brano, cioè fino alla prima
			// punteggiatura
			punteggiature = riferimento.indexOf(',');
			if (punteggiature < 0 || (riferimento.indexOf(';') < punteggiature && riferimento.indexOf(';') >= 0)) {
				punteggiature = riferimento.indexOf(';');
			}
			if (punteggiature < 0 || (riferimento.indexOf('-') < punteggiature && riferimento.indexOf('-') >= 0)) {
				punteggiature = riferimento.indexOf('-');
				if (punteggiature >= 0) {
					trattino = true;
				}
			}
			if (punteggiature >= 0) {
				riferimentoDaAnalizzare = riferimento.substring(0, punteggiature);
				// il riferimento del primo brano
				riferimento = funzioni.Rimuovi(riferimento, 0, punteggiature + 1).trim();
				// il resto del riferimento, che analizzeremo più tardi
			} else {
				riferimentoDaAnalizzare = riferimento;
				riferimento = "";
			}
			riferimentoBrano = ConvertiRiferimentoDaTestoA4Byte(riferimentoDaAnalizzare, trattinoVecchio);
			// il primo brano, in formatto a 4 byte
			if (riferimentoBrano[0] == 0 && !riferimentoDaAnalizzare.equals("") && (!Character.isLetter(riferimentoDaAnalizzare.charAt(0)))) {
				if (riferimentoDaAnalizzare.indexOf(':') == -1 && riferimentoDaAnalizzare.indexOf('.') == -1 && !versettoMancante) {
					riferimentoDaAnalizzare = Integer.toString(capitolo) + ":" + riferimentoDaAnalizzare;
				}
				riferimentoDaAnalizzare = libroNome + riferimentoDaAnalizzare;
				riferimentoBrano = ConvertiRiferimentoDaTestoA4Byte(riferimentoDaAnalizzare, trattinoVecchio);
			}
			versettoMancante = false;
			if (riferimentoBrano[0] > 0) {
				riferimentoBrano4Byte = riferimentoBrano;
				if (riferimentoDaAnalizzare.indexOf(':') == -1 && riferimentoDaAnalizzare.indexOf('.') == -1) {
					versettoMancante = true;
					if (trattino) {
						if (!riferimento.equals("") && (!Character.isLetter(riferimento.charAt(0))) && (riferimento.length() == 1 || (!Character.isLetter(riferimento.charAt(1))))) {
							riferimento = libriAbbreviazioniUsate[riferimentoBrano4Byte[0]] + riferimento;
						}
					} else {
						if (trattinoVecchio) {
							trattino = true;
							riferimento = riferimentoDaAnalizzare + ";" + riferimento;
						}
					}
				}
				libroNome = libriAbbreviazioniUsate[riferimentoBrano4Byte[0]];
				capitolo = riferimentoBrano4Byte[1];
			}
			if (!trattinoVecchio) {
				riferimentoBrano[4] = riferimentoBrano[0];
				riferimentoBrano[5] = riferimentoBrano[1];
				riferimentoBrano[6] = riferimentoBrano[2];
				riferimentoBrano[7] = riferimentoBrano[3];
				riferimentoBrano[0] = riferimentoBranoPrecedente[0];
				riferimentoBrano[1] = riferimentoBranoPrecedente[1];
				riferimentoBrano[2] = riferimentoBranoPrecedente[2];
				riferimentoBrano[3] = riferimentoBranoPrecedente[3];
				trattinoVecchio = true;
			} else {
				if (trattino) {
					trattinoVecchio = false;
					trattino = false;
					riferimentoBranoPrecedente[0] = riferimentoBrano[0];
					riferimentoBranoPrecedente[1] = riferimentoBrano[1];
					riferimentoBranoPrecedente[2] = riferimentoBrano[2];
					riferimentoBranoPrecedente[3] = riferimentoBrano[3];
				} else {
					riferimentoBrano[4] = riferimentoBrano[0];
					riferimentoBrano[5] = riferimentoBrano[1];
					riferimentoBrano[6] = riferimentoBrano[2];
					riferimentoBrano[7] = riferimentoBrano[3];
				}
			}
			if (riferimentoBrano[0] > 0 && riferimentoBrano[4] > 0) {
				nuovoRiferimento.aggiungiBrano8Int(riferimentoBrano);
			}
		} while (!riferimento.equals(""));
		return nuovoRiferimento;
	}

	private int[] ConvertiRiferimentoDaTestoA4Byte(String riferimentoTestuale, boolean primaDelTrattino) {
		// convertire a 4 interi un riferimento di un versetto+parola
		// se primaDelTrattino = false, il riferimento va dopo il trattino
		int[] riferimentoRestituito = { 0, 0, 0, 0, 0, 0, 0, 0 };
		int primaNonLettera = -1;
		String riferimento = riferimentoTestuale.toLowerCase().trim();
		if (riferimento.equals("")) {
			return riferimentoRestituito;
		}

		String nomeLibro = "";
		if (riferimento.charAt(0) >= '1' && riferimento.charAt(0) <= '3') {
			nomeLibro = riferimento.substring(0, 1);
			riferimento = funzioni.Rimuovi(riferimento, 0, 1).trim();
		}

		do {
			++primaNonLettera;
		} while (primaNonLettera < riferimento.length() - 1 && Character.isLetter(riferimento.charAt(primaNonLettera)));

		String riferimentoRimanente = "";
		int capitolo = 0, versetto = 0, parola = 0;
		if (primaNonLettera == riferimento.length() - 1 && Character.isLetter(riferimento.charAt(riferimento.length() - 1))) {
			nomeLibro += riferimento;
		} else {
			nomeLibro += riferimento.substring(0, primaNonLettera);
			riferimentoRimanente = riferimento.substring(primaNonLettera).trim();
			StringBuilder capitoloNumerico = new StringBuilder("");
			for (int j = 0; j < riferimentoRimanente.length() && Character.isDigit(riferimentoRimanente.charAt(j)); ++j) {
				capitoloNumerico.append(riferimentoRimanente.substring(j, j + 1));
			}
			try {
				capitolo = Integer.parseInt(capitoloNumerico.toString());
			} catch (NumberFormatException e) {
				capitolo = 0;
			}
		}

		if (!riferimentoRimanente.equals("")) {
			int posDivisoreCapitoloVersetto = riferimentoRimanente.indexOf(":");
			if (posDivisoreCapitoloVersetto == -1 || (riferimentoRimanente.indexOf(".") < posDivisoreCapitoloVersetto && riferimentoRimanente.indexOf(".") >= 0)) {
				posDivisoreCapitoloVersetto = riferimentoRimanente.indexOf(".");
			}
			if ((formato.RiferimentoTipo() == RiferimentoTipo.Virgola || formato.RiferimentoTipo() == RiferimentoTipo.Citazione)
					&& (posDivisoreCapitoloVersetto == -1 || (riferimentoRimanente.indexOf(",") < posDivisoreCapitoloVersetto && riferimentoRimanente.indexOf(",") >= 0))) {
				posDivisoreCapitoloVersetto = riferimentoRimanente.indexOf(",");
			}
			if (posDivisoreCapitoloVersetto >= 0) {
				riferimentoRimanente = funzioni.Rimuovi(riferimentoRimanente, 0, posDivisoreCapitoloVersetto + 1).trim();
			} else {
				riferimentoRimanente = "";
			}
			StringBuilder versettoNumerico = new StringBuilder("");
			for (int j = 0; j < riferimentoRimanente.length() && Character.isDigit(riferimentoRimanente.charAt(j)); ++j) {
				versettoNumerico.append(riferimentoRimanente.substring(j, j + 1));
			}
			try {
				versetto = Integer.parseInt(versettoNumerico.toString());
			} catch (NumberFormatException e) {
				versetto = 0;
			}
		}

		// trovare eventuale parola dopo /
		if (!riferimentoRimanente.equals("")) {
			int posDivisoreVersettoParola = riferimentoRimanente.indexOf("/");
			if (posDivisoreVersettoParola >= 0) {
				riferimentoRimanente = funzioni.Rimuovi(riferimentoRimanente, 0, posDivisoreVersettoParola + 1).trim();
			} else {
				riferimentoRimanente = "";
			}
			StringBuilder parolaNumerico = new StringBuilder("");
			for (int j = 0; j < riferimentoRimanente.length() && Character.isDigit(riferimentoRimanente.charAt(j)); ++j) {
				parolaNumerico.append(riferimentoRimanente.substring(j, j + 1));
			}
			try {
				parola = Integer.parseInt(parolaNumerico.toString());
			} catch (NumberFormatException e) {
				parola = 0;
			}
		}

		int libro = GetLibroNumeroDaAbbreviazione(nomeLibro);

		if (libro > 0) {
			riferimentoRestituito[0] = libro;
			if ((libro == 38 || libro == 64 || libro == 70 || libro == 71 || libro == 72) && versetto == 0) {
				versetto = capitolo;
				capitolo = 1;
			}
			if (capitolo == 0) {
				if (primaDelTrattino) {
					riferimentoRestituito[1] = 1;
					riferimentoRestituito[2] = 1;
				} else {
					riferimentoRestituito[1] = 255;
					riferimentoRestituito[2] = 255;
				}
			} // if (iCapitolo==0)
			else {
				riferimentoRestituito[1] = capitolo;
				if (versetto == 0) {
					if (primaDelTrattino) {
						versetto = 1;
					} else {
						versetto = 255;
					}
				}
				riferimentoRestituito[2] = versetto;
			}
		} // if (!string.IsNullOrEmpty(rifOut))

		riferimentoRestituito[3] = parola;

		return riferimentoRestituito;
	}

	private int GetLibroNumeroDaAbbreviazione(String abbreviazione) {
		if (!abbreviazione.equals("")) {
			abbreviazione = abbreviazione.toLowerCase();
			for (int numeroLettere = abbreviazione.length(); numeroLettere > 0; --numeroLettere) {
				if (libriAbbreviazioniRiconosciute.ContainsKey(abbreviazione.substring(0, numeroLettere))) {
					return libriAbbreviazioniRiconosciute.get(abbreviazione.substring(0, numeroLettere));
				}
			}
		}
		return 0;
	}

	public String getLibroNome(int numeroLibro) {
		return ((numeroLibro >= 1 && numeroLibro <= 73) ? libriNomi[numeroLibro] : "");
	}

	public void setLibroNome(int numeroLibro, String nome) {
		if (numeroLibro >= 1 && numeroLibro <= 73) {
			libriNomi[numeroLibro] = nome;
		}
	}

	public int capitoliInLibro(int libro, String nomeVersione) {
		return getTesto(nomeVersione).capitoliInLibro[libro];
	}

	public int capitoliFinoALibro(int libro, String nomeVersione) {
		return getTesto(nomeVersione).indiceLibri[libro - 1];
	}

	public int versettiInCapitolo(int libro, int capitolo, String nomeVersione) {
		if (getTesto(nomeVersione).capitoliInLibro[libro] == 0)
			return 0;
		else
			return getTesto(nomeVersione).versettiInCapitolo[getTesto(nomeVersione).indiceLibri[libro - 1] + capitolo];
	}

	public int versettiFinoACapitolo(int libro, int capitolo, String nomeVersione) {
		return getTesto(nomeVersione).indiceCapitoli[getTesto(nomeVersione).indiceLibri[libro-1] + capitolo];
	}

	// Il numero di un libro in cui è un certo capitolo della Bibbia (contando da 1 a circa 1300).
	// capitolo: Il capitolo da cercare (1-50 in Genesi, 51-90 in Esodo, ecc.).
	// Restituisce il numero del libro (1=Genesi, 47=Matteo, 73=Apocalisse)
	public int libroDiCapitolo(int capitolo, String nomeVersione) {
		if (capitolo < 1)
			capitolo = 1;
		int libro = 0;
		do {
			libro++;
		} while (libro <= 73 && capitoliFinoALibro(libro, nomeVersione) < capitolo);
		return libro;
	}

	// Il riferimento in cui è un certo versetto della Bibbia (contando da 1 a circa 31000).
	// Versetto: Il numero del versetto da cercare (1-31 in Genesi 1, 32-56 in Genesi 2, ecc.).
	// Restituisce il riferimento del versetto.
	public Riferimento riferimentoDiVersetto(int versetto, String nomeVersione) {
		if (versetto < 1)
			versetto = 1;
		int libro = 0;
		do {
			libro++;
		} while (libro <= 73 && versettiFinoACapitolo(libro, capitoliInLibro(libro, nomeVersione), nomeVersione) < versetto);

		int capitolo = 0;
		do {
			capitolo++;
		} while (versettiFinoACapitolo(libro, capitolo, nomeVersione) < versetto);

		return new Riferimento(libro, capitolo, versetto - versettiFinoACapitolo(libro - 1, capitolo - 1, nomeVersione) + versettiInCapitolo(libro - 1, capitolo - 1, nomeVersione));
	}

	public String[] separatoriNeiRiferimenti() {
		String[] separatori = new String[3];
		switch (formato.RiferimentoTipo()) {
		case Virgola:
			separatori[0] = " ";
			separatori[1] = ",";
			separatori[2] = ".";
			break;
		case Citazione:
			separatori[0] = ((formato.RiferimentoFormato() == RiferimentoFormato.Abbreviazione) ? "., " : ", ");
			separatori[1] = ", ";
			separatori[2] = ".";
			break;
		default: // DuePunti o valori illegali
			separatori[0] = " ";
			separatori[1] = ":";
			separatori[2] = ",";
			break;
		}
		return separatori;
	}
}
